diff --git a/src/gui/painting/qdrawhelper.cpp b/src/gui/painting/qdrawhelper.cpp
index b3f9fd9..2399acf 100644
--- a/src/gui/painting/qdrawhelper.cpp
+++ b/src/gui/painting/qdrawhelper.cpp
@@ -6014,6 +6369,14 @@ static void qt_rectfill_gray(QRasterBuffer *rasterBuffer,
                          qGray(color.toArgb32()), x, y, width, height, rasterBuffer->bytesPerLine());
 }
 
+static void qt_rectfill_rgb64(QRasterBuffer *rasterBuffer,
+                              int x, int y, int width, int height,
+                              const QRgba64 &color)
+{
+    qt_rectfill<quint64>(reinterpret_cast<quint64 *>(rasterBuffer->buffer()),
+                         color, x, y, width, height, rasterBuffer->bytesPerLine());
+}
+
 // Map table for destination image format. Contains function pointers
 // for blends of various types unto the destination
 
@@ -6212,6 +6575,26 @@ DrawHelper qDrawHelper[QImage::NImageFormats] =
         0, 0, 0,
         qt_rectfill_gray
     },
+    // Format_Grayscale16
+    {
+        blend_color_generic_rgb64,
+        blend_src_generic_rgb64,
+        0, 0, 0, 0
+    },
+    // Format_RGBX64
+    {
+        blend_color_generic_rgb64,
+        blend_src_generic_rgb64,
+        0, 0, 0,
+        qt_rectfill_rgb64
+    },
+    // Format_RGBA64_Premultiplied
+    {
+        blend_color_generic_rgb64,
+        blend_src_generic_rgb64,
+        0, 0, 0,
+        qt_rectfill_rgb64
+    },
 };
 
 #if defined(Q_CC_MSVC) && !defined(_MIPS_)
diff --git a/src/gui/painting/qdrawhelper_p.h b/src/gui/painting/qdrawhelper_p.h
index f8865a6..4271a18 100644
--- a/src/gui/painting/qdrawhelper_p.h
+++ b/src/gui/painting/qdrawhelper_p.h
@@ -1025,8 +1025,14 @@ inline int qBlue565(quint16 rgb) {
 
 static Q_ALWAYS_INLINE const uint *qt_convertARGB32ToARGB32PM(uint *buffer, const uint *src, int count)
 {
-    for (int i = 0; i < count; ++i)
-        buffer[i] = qPremultiply(src[i]);
+    // We explicitly split the aliased case to force the compiler to make optimized code paths for each case.
+    if (buffer == src) {
+        for (int i = 0; i < count; ++i)
+            buffer[i] = qPremultiply(buffer[i]);
+    } else {
+        for (int i = 0; i < count; ++i)
+            buffer[i] = qPremultiply(src[i]);
+    }
     return buffer;
 }
 
@@ -1104,7 +1110,7 @@ inline int comp_func_Plus_one_pixel(uint d, const uint s)
 struct QPixelLayout;
 typedef const uint *(QT_FASTCALL *ConvertFunc)(uint *buffer, const uint *src, int count,
                                                const QPixelLayout *layout, const QRgb *clut);
-typedef const QRgba64 *(QT_FASTCALL *ConvertFunc64)(QRgba64 *buffer, const uint *src, int count,
+typedef const QRgba64 *(QT_FASTCALL *ConvertFunc64)(QRgba64 *buffer, const quint64 *src, int count,
                                                     const QPixelLayout *layout, const QRgb *clut);
 
 struct QPixelLayout
@@ -1118,6 +1124,7 @@ struct QPixelLayout
         BPP16,
         BPP24,
         BPP32,
+        BPP64,
         BPPCount
     };
 
@@ -1141,11 +1148,14 @@ struct QPixelLayout
 typedef const uint *(QT_FASTCALL *FetchPixelsFunc)(uint *buffer, const uchar *src, int index, int count);
 typedef void (QT_FASTCALL *StorePixelsFunc)(uchar *dest, const uint *src, int index, int count);
 
+typedef const quint64 *(QT_FASTCALL *FetchPixelsFunc64)(quint64 *buffer, const uchar *src, int index, int count);
+typedef void (QT_FASTCALL *StorePixelsFunc64)(uchar *dest, const quint64 *src, int index, int count);
+
 extern QPixelLayout qPixelLayouts[QImage::NImageFormats];
 extern FetchPixelsFunc qFetchPixels[QPixelLayout::BPPCount];
 extern StorePixelsFunc qStorePixels[QPixelLayout::BPPCount];
-
-
+extern FetchPixelsFunc64 qFetchPixels64[QPixelLayout::BPPCount];
+extern StorePixelsFunc64 qStorePixels64[QPixelLayout::BPPCount];
 
 QT_END_NAMESPACE
 
diff --git a/src/gui/painting/qmemrotate.cpp b/src/gui/painting/qmemrotate.cpp
index f205cb1..9b8958a 100644
--- a/src/gui/painting/qmemrotate.cpp
+++ b/src/gui/painting/qmemrotate.cpp
@@ -465,9 +465,7 @@ Q_GUI_EXPORT void qt_memrotate270(const type *src, int w, int h, int sstride, \
     qt_memrotate270_tiled_unpacked<type>(src, w, h, sstride, dest, dstride); \
 }
 
-
-
-
+QT_IMPL_MEMROTATE(quint64)
 QT_IMPL_MEMROTATE(quint32)
 QT_IMPL_MEMROTATE(quint16)
 QT_IMPL_MEMROTATE(quint24)
@@ -518,6 +516,21 @@ void qt_memrotate270_32(const uchar *srcPixels, int w, int h, int sbpl, uchar *d
     qt_memrotate270((const uint *)srcPixels, w, h, sbpl, (uint *)destPixels, dbpl);
 }
 
+void qt_memrotate90_64(const uchar *srcPixels, int w, int h, int sbpl, uchar *destPixels, int dbpl)
+{
+    qt_memrotate90((const quint64 *)srcPixels, w, h, sbpl, (quint64 *)destPixels, dbpl);
+}
+
+void qt_memrotate180_64(const uchar *srcPixels, int w, int h, int sbpl, uchar *destPixels, int dbpl)
+{
+    qt_memrotate180((const quint64 *)srcPixels, w, h, sbpl, (quint64 *)destPixels, dbpl);
+}
+
+void qt_memrotate270_64(const uchar *srcPixels, int w, int h, int sbpl, uchar *destPixels, int dbpl)
+{
+    qt_memrotate270((const quint64 *)srcPixels, w, h, sbpl, (quint64 *)destPixels, dbpl);
+}
+
 MemRotateFunc qMemRotateFunctions[QImage::NImageFormats][3] =
 // 90, 180, 270
 {
@@ -546,6 +559,9 @@ MemRotateFunc qMemRotateFunctions[QImage::NImageFormats][3] =
     { qt_memrotate90_32, qt_memrotate180_32, qt_memrotate270_32 },      // Format_A2RGB30_Premultiplied,
     { qt_memrotate90_8, qt_memrotate180_8, qt_memrotate270_8 },         // Format_Alpha8,
     { qt_memrotate90_8, qt_memrotate180_8, qt_memrotate270_8 },         // Format_Grayscale8,
+    { qt_memrotate90_16, qt_memrotate180_16, qt_memrotate270_16 },      // Format_Grayscale16,
+    { qt_memrotate90_64, qt_memrotate180_64, qt_memrotate270_64 },      // Format_RGBX64
+    { qt_memrotate90_64, qt_memrotate180_64, qt_memrotate270_64 },      // Format_RGBA64_Premultiplied
 };
 
 QT_END_NAMESPACE
diff --git a/src/gui/painting/qmemrotate_p.h b/src/gui/painting/qmemrotate_p.h
index ece6e94..3d209e3 100644
--- a/src/gui/painting/qmemrotate_p.h
+++ b/src/gui/painting/qmemrotate_p.h
@@ -71,6 +71,7 @@ QT_DECL_MEMROTATE(quint32);
 QT_DECL_MEMROTATE(quint16);
 QT_DECL_MEMROTATE(quint24);
 QT_DECL_MEMROTATE(quint8);
+QT_DECL_MEMROTATE(quint64);
 
 #undef QT_DECL_MEMROTATE
 
diff --git a/src/gui/painting/qrgb.h b/src/gui/painting/qrgb.h
index 05b3a76..7acbdb3 100644
--- a/src/gui/painting/qrgb.h
+++ b/src/gui/painting/qrgb.h
@@ -68,12 +68,19 @@ inline Q_DECL_CONSTEXPR QRgb qRgb(int r, int g, int b)// set RGB value
 inline Q_DECL_CONSTEXPR QRgb qRgba(int r, int g, int b, int a)// set RGBA value
 { return ((a & 0xff) << 24) | ((r & 0xff) << 16) | ((g & 0xff) << 8) | (b & 0xff); }
 
-inline Q_DECL_CONSTEXPR int qGray(int r, int g, int b)// convert R,G,B to gray 0..255
+inline Q_DECL_CONSTEXPR int qGray(int r, int g, int b)      // convert R,G,B to gray 0..255
 { return (r*11+g*16+b*5)/32; }
 
-inline Q_DECL_CONSTEXPR int qGray(QRgb rgb)                // convert RGB to gray 0..255
+inline Q_DECL_CONSTEXPR int qGray16(int r, int g, int b)    // convert R,G,B to gray 0..65535
+{ return (r*110+g*366+b*38)/2; }
+//{ return (r*299+g*587+b*138+2)/4; }
+
+inline Q_DECL_CONSTEXPR int qGray(QRgb rgb)                 // convert RGB to gray 0..255
 { return qGray(qRed(rgb), qGreen(rgb), qBlue(rgb)); }
 
+inline Q_DECL_CONSTEXPR int qGray16(QRgb rgb)               // convert RGB to gray 0..65535
+{ return qGray16(qRed(rgb), qGreen(rgb), qBlue(rgb)); }
+
 inline Q_DECL_CONSTEXPR bool qIsGray(QRgb rgb)
 { return qRed(rgb) == qGreen(rgb) && qRed(rgb) == qBlue(rgb); }
 
diff --git a/tests/auto/gui/image/qimagewriter/tst_qimagewriter.cpp b/tests/auto/gui/image/qimagewriter/tst_qimagewriter.cpp
index 4f04e50..ecbab60 100644
--- a/tests/auto/gui/image/qimagewriter/tst_qimagewriter.cpp
+++ b/tests/auto/gui/image/qimagewriter/tst_qimagewriter.cpp
@@ -266,18 +266,16 @@ void tst_QImageWriter::writeImage2_data()
     QImage image0(70, 70, QImage::Format_ARGB32);
     image0.fill(QColor(Qt::red).rgb());
 
-    QImage::Format imgFormat = QImage::Format_Mono;
-    while (imgFormat != QImage::NImageFormats) {
-        QImage image = image0.convertToFormat(imgFormat);
+    for (int i = QImage::Format_Mono; i < QImage::NImageFormats; ++i) {
+        QImage image = image0.convertToFormat(QImage::Format(i));
         initializePadding(&image);
         foreach (const QString format, formats) {
-            const QString fileName = QString("solidcolor_%1.%2").arg(imgFormat)
+            const QString fileName = QString("solidcolor_%1.%2").arg(i)
                                      .arg(format);
             QTest::newRow(fileName.toLatin1()) << fileName
                                                << format.toLatin1()
                                                << image;
         }
-        imgFormat = QImage::Format(int(imgFormat) + 1);
     }
 }
 
